import { flags } from '@oclif/command';
import JBrowseCommand from '../base';
interface UriLocation {
    uri: string;
    locationType: 'UriLocation';
}
interface LocalPathLocation {
    localPath: string;
    locationType: 'LocalPathLocation';
}
export default class AddTrack extends JBrowseCommand {
    target: string;
    static description: string;
    static examples: string[];
    static args: {
        name: string;
        required: boolean;
        description: string;
    }[];
    static flags: {
        trackType: flags.IOptionFlag<string | undefined>;
        name: flags.IOptionFlag<string | undefined>;
        indexFile: flags.IOptionFlag<string | undefined>;
        description: flags.IOptionFlag<string | undefined>;
        assemblyNames: flags.IOptionFlag<string | undefined>;
        category: flags.IOptionFlag<string | undefined>;
        config: flags.IOptionFlag<string | undefined>;
        target: flags.IOptionFlag<string | undefined>;
        out: flags.IOptionFlag<string | undefined>;
        subDir: flags.IOptionFlag<string>;
        help: import("@oclif/parser/lib/flags").IBooleanFlag<void>;
        trackId: flags.IOptionFlag<string | undefined>;
        load: flags.IOptionFlag<string | undefined>;
        skipCheck: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        overwrite: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        force: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        protocol: flags.IOptionFlag<string>;
    };
    run(): Promise<void>;
    guessFileNames(fileName: string, index?: string): {
        file: string;
        index: string;
        index2?: undefined;
    } | {
        file: string;
        index?: undefined;
        index2?: undefined;
    } | {
        file?: undefined;
        index?: undefined;
        index2?: undefined;
    } | {
        file: string;
        index: string;
        index2: string;
    };
    guessAdapter(fileName: string, protocol: string, index?: string): {
        type: string;
        bamLocation: UriLocation | LocalPathLocation;
        index: {
            location: UriLocation | LocalPathLocation;
            indexType: string;
        };
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        cramLocation: UriLocation | LocalPathLocation;
        craiLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        gffLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        gffGzLocation: UriLocation | LocalPathLocation;
        index: {
            location: UriLocation | LocalPathLocation;
            indexType: string;
        };
        bamLocation?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        gtfLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        vcfLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        vcfGzLocation: UriLocation | LocalPathLocation;
        index: {
            location: UriLocation | LocalPathLocation;
            indexType: string;
        };
        bamLocation?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        bedGzLocation: UriLocation | LocalPathLocation;
        index: {
            location: UriLocation | LocalPathLocation;
            indexType: string;
        };
        bamLocation?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        bigBedLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        bigWigLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        fastaLocation: UriLocation | LocalPathLocation;
        faiLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        fastaLocation: UriLocation | LocalPathLocation;
        faiLocation: UriLocation | LocalPathLocation;
        gziLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        twoBitLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        rootUrlTemplate: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        endpoint: string;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        hicLocation?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        hicLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        pafLocation?: undefined;
    } | {
        type: string;
        pafLocation: UriLocation | LocalPathLocation;
        bamLocation?: undefined;
        index?: undefined;
        cramLocation?: undefined;
        craiLocation?: undefined;
        gffLocation?: undefined;
        gffGzLocation?: undefined;
        gtfLocation?: undefined;
        vcfLocation?: undefined;
        vcfGzLocation?: undefined;
        bedGzLocation?: undefined;
        bigBedLocation?: undefined;
        bigWigLocation?: undefined;
        fastaLocation?: undefined;
        faiLocation?: undefined;
        gziLocation?: undefined;
        twoBitLocation?: undefined;
        rootUrlTemplate?: undefined;
        endpoint?: undefined;
        hicLocation?: undefined;
    };
    guessTrackType(adapterType: string): string;
}
export {};
